Attribute VB_Name = "Module1"

Public Function TimeInterval(StDate As Date, EnDate As Date, TimeUnit As Integer)
    ' args: StartD & EndD
    ' args: TimeUnit 1=year, 2=month, 3=day, 4=hour, 5=minute, 6=second
    ' returns: integer age in selected unit

    Dim SD As Date              'startdate
    Dim ED As Date              'enddate
    Dim TD As Date              'temp date
    Dim x As Integer            'counter
    Dim y As Integer            'counter
    Dim Unit As String          'yr/mon/day/hr/min/sec DateAdd constants
    Dim strMsg As String        'msgbox string
    Dim UnitFlag As Boolean     'indicates if return value is + or -
    ' check timeunit arg, returns zero if bad
    If TimeUnit < 1 Or TimeUnit > 6 Then
        strMsg = MsgBox("Time Unit Argument must be integer 1 to 6", vbOKOnly, "Argumnet Error")
        TimeInterval = 0
        Exit Function
    End If
    SD = StDate
    ED = EnDate
    ' set unitflag to + or - & reverse dates if negative
    If ED >= SD Then
            UnitFlag = True
        Else
            UnitFlag = False
            TD = SD
            SD = ED
            ED = TD
    End If
    ' work to specified timeunit
    For x = 1 To TimeUnit
        ' for 5 time measurement units ("S" for seconds does not calc properly!)
        Select Case x
            Case 1
                Unit = "YYYY"           'year
            Case 2
                Unit = "M"              'month
            Case 3
                Unit = "D"              'day
            Case 4
                Unit = "H"              'hour
            Case 5
                Unit = "N"              'minute
        End Select
        ' for yr/mon/day/hr/min
        If x < 6 Then
                ' initilize unit counter
                y = 0
                ' increment y & sd unit by 1 unit, until sd > ed
                Do While SD <= ED
                    SD = DateAdd(Unit, 1, SD)
                    y = y + 1
                Loop
                ' decrement sd by 1 unit
                SD = DateAdd(Unit, -1, SD)
            Else
                ' use datediff on seconds and add 1 to result
                y = DateDiff("S", SD, ED) + 1
        End If
    Next x
    ' minus 1 from results and set return value as + or -
    TimeInterval = (y - 1) * IIf(UnitFlag, 1, -1)
End Function


